'////////////////////////////////////////////////////////////////////////////////
'	MultipleWiimoteForm.cs
'	Managed Wiimote Library Tester
'	Written by Brian Peek (http://www.brianpeek.com/)
'  for MSDN's Coding4Fun (http://msdn.microsoft.com/coding4fun/)
'	Visit http://blogs.msdn.com/coding4fun/archive/2007/03/14/1879033.aspx
'  and http://www.codeplex.com/WiimoteLib
'  for more information
'////////////////////////////////////////////////////////////////////////////////


Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Windows.Forms
Imports WiimoteLib

Namespace WiimoteTest
	Partial Public Class WiimoteInfo
        Inherits UserControl
        Dim tx As New umFish50
		Private Delegate Sub UpdateWiimoteStateDelegate(ByVal args As WiimoteChangedEventArgs)
		Private Delegate Sub UpdateExtensionChangedDelegate(ByVal args As WiimoteExtensionChangedEventArgs)

		Private b As New Bitmap(256, 192, PixelFormat.Format24bppRgb)
		Private g As Graphics
		Private mWiimote As Wiimote

		Public Sub New()
			InitializeComponent()
			g = Graphics.FromImage(b)
		End Sub

		Public Sub New(ByVal wm As Wiimote)
			Me.New()
			mWiimote = wm
		End Sub

		Public Sub UpdateState(ByVal args As WiimoteChangedEventArgs)
			BeginInvoke(New UpdateWiimoteStateDelegate(AddressOf UpdateWiimoteChanged), args)
		End Sub

		Public Sub UpdateExtension(ByVal args As WiimoteExtensionChangedEventArgs)
			BeginInvoke(New UpdateExtensionChangedDelegate(AddressOf UpdateExtensionChanged), args)
		End Sub

        Dim x As Integer
		Private Sub UpdateWiimoteChanged(ByVal args As WiimoteChangedEventArgs)
			Dim ws As WiimoteState = args.WiimoteState
            x = ws.IRState.RawMidpoint.X
            If ws.IRState.IRSensors.GetValue(0).Found = True Then
                If 400 < x And x < 700 Then
                    tx.txSetMotor(0, 0, 2, 512)
                    tx.txSetMotor(0, 1, 2, 512)
                ElseIf x < 400 Then
                    tx.txSetMotor(0, 0, 2, 512)
                    tx.txSetMotor(0, 1, 1, 512)
                ElseIf x > 700 Then
                    tx.txSetMotor(0, 0, 1, 512)
                    tx.txSetMotor(0, 1, 2, 512)
                Else
                    tx.txSetMotor(0, 0, 0, 512)
                    tx.txSetMotor(0, 1, 0, 512)


                End If


            Else

                tx.txSetMotor(0, 0, 1, 512)
                tx.txSetMotor(0, 1, 2, 512)
            End If

            CheckBox1.Text = ws.IRState.RawMidpoint.X

        End Sub

		Private Sub UpdateIR(ByVal irSensor As IRSensor, ByVal lblNorm As Label, ByVal lblRaw As Label, ByVal chkFound As CheckBox, ByVal color As Color)
			chkFound.Checked = irSensor.Found

			If irSensor.Found Then
				lblNorm.Text = irSensor.Position.ToString() & ", " & irSensor.Size
				lblRaw.Text = irSensor.RawPosition.ToString()
				g.DrawEllipse(New Pen(color), CInt(Fix(irSensor.RawPosition.X / 4)), CInt(Fix(irSensor.RawPosition.Y / 4)), irSensor.Size+1, irSensor.Size+1)
			End If
		End Sub

		Private Sub UpdateExtensionChanged(ByVal args As WiimoteExtensionChangedEventArgs)
			
		End Sub

		Public WriteOnly Property Wiimote() As Wiimote
			Set(ByVal value As Wiimote)
				mWiimote = value
			End Set
		End Property

        Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged

        End Sub
    End Class
End Namespace
